Index: owl.c
===================================================================
--- owl.c	(revision 6fe806ae890b6a1616bd442639d297349a7d8d20)
+++ owl.c	(revision eebef194307e93a0e2956946794840c21dd8c4ba)
@@ -48,5 +48,4 @@
 #include <termios.h>
 #include <sys/stat.h>
-#include <locale.h>
 #include "owl.h"
 
@@ -70,6 +69,5 @@
   owl_editwin *tw;
   owl_popwin *pw;
-  int ret, initialsubs, debug, argcsave, followlast;
-  owl_input j;
+  int j, ret, initialsubs, debug, argcsave, followlast;
   int newmsgs, nexttimediff;
   struct sigaction sigact;
@@ -86,7 +84,4 @@
   int newstderr;
 #endif
-  
-  if (!GLIB_CHECK_VERSION (2, 12, 0))
-    g_error ("GLib version 2.12.0 or above is needed.");
 
   argcsave=argc;
@@ -97,7 +92,4 @@
   debug=0;
   initialsubs=1;
-
-  setlocale(LC_ALL, "");
-  
   if (argc>0) {
     argv++;
@@ -538,53 +530,8 @@
      * little bit, but otherwise do not.  This lets input be grabbed
      * as quickly as possbile */
-    j.ch = wgetch(typwin);
-    if (j.ch == ERR) {
+    j=wgetch(typwin);
+    if (j==ERR) {
       usleep(10000);
     } else {
-      j.uch = '\0';
-      if (j.ch >= KEY_MIN && j.ch <= KEY_MAX) {
-	/* This is a curses control character. */
-      }
-      else if (j.ch > 0x7f && j.ch < 0xfe) {
-	/* Pull in a full utf-8 character. */
-	int bytes, i;
-	char utf8buf[7];
-	memset(utf8buf, '\0', 7);
-
-	utf8buf[0] = j.ch;
-
-	if ((j.ch & 0xc0) && (~j.ch & 0x20)) bytes = 2;
-	else if ((j.ch & 0xe0) && (~j.ch & 0x10)) bytes = 3;
-	else if ((j.ch & 0xf0) && (~j.ch & 0x08)) bytes = 4;
-	else if ((j.ch & 0xf8) && (~j.ch & 0x04)) bytes = 5;
-	else if ((j.ch & 0xfc) && (~j.ch & 0x02)) bytes = 6;
-	else bytes = 1;
-	
-	for (i = 1; i < bytes; i++) {
-          int tmp =  wgetch(typwin);
-          /* If what we got was not a byte, or not a continuation byte */
-          if (tmp > 0xff || !(tmp & 0x80 && ~tmp & 0x40)) {
-            /* ill-formed UTF-8 code unit subsequence, put back the
-               char we just got. */
-            ungetch(tmp);
-            j.ch = ERR;
-            break;
-          }
-	  utf8buf[i] = tmp;
-        }
-        
-	if (j.ch != ERR) {
-          if (g_utf8_validate(utf8buf, -1, NULL)) {
-            j.uch = g_utf8_get_char(utf8buf);
-          }
-          else {
-            j.ch = ERR;
-          }
-        }
-      }
-      else if (j.ch <= 0x7f) {
-	j.uch = j.ch;
-      }
-      
       owl_global_set_lastinputtime(&g, now);
       /* find and activate the current keymap.
Index: owl.h
===================================================================
--- owl.h	(revision 88dc766f92b555243e8aa1fdd3dde181bd80a04a)
+++ owl.h	(revision 88dc766f92b555243e8aa1fdd3dde181bd80a04a)
@@ -52,7 +52,5 @@
 #include <termios.h>
 #include <libfaim/aim.h>
-#include <wchar.h>
 #include "config.h"
-#include "glib.h"
 #ifdef HAVE_LIBZEPHYR
 #include <zephyr/zephyr.h>
@@ -102,24 +100,4 @@
 #define OWL_FMTEXT_ATTR_REVERSE   2
 #define OWL_FMTEXT_ATTR_UNDERLINE 4
-
-#define OWL_FMTEXT_UC_BASE 0x100000 /* Unicode Plane 16 - Supplementary Private Use Area-B*/
-#define OWL_FMTEXT_UC_ATTR ( OWL_FMTEXT_UC_BASE | 0x800 )
-#define OWL_FMTEXT_UC_ATTR_MASK 0x7
-#define OWL_FMTEXT_UC_COLOR_BASE ( OWL_FMTEXT_UC_BASE | 0x400 )
-#define OWL_FMTEXT_UC_FGCOLOR OWL_FMTEXT_UC_COLOR_BASE
-#define OWL_FMTEXT_UC_BGCOLOR ( OWL_FMTEXT_UC_COLOR_BASE | 0x200 )
-#define OWL_FMTEXT_UC_DEFAULT_COLOR 0x100
-#define OWL_FMTEXT_UC_FGDEFAULT ( OWL_FMTEXT_UC_FGCOLOR | OWL_FMTEXT_UC_DEFAULT_COLOR )
-#define OWL_FMTEXT_UC_BGDEFAULT ( OWL_FMTEXT_UC_BGCOLOR | OWL_FMTEXT_UC_DEFAULT_COLOR )
-#define OWL_FMTEXT_UC_COLOR_MASK 0xFF
-#define OWL_FMTEXT_UC_ALLCOLOR_MASK ( OWL_FMTEXT_UC_COLOR_MASK | OWL_FMTEXT_UC_DEFAULT_COLOR | 0x200)
-#define OWL_FMTEXT_UC_STARTBYTE_UTF8 '\xf4'
-
-#define OWL_FMTEXT_UTF8_ATTR_NONE "\xf4\x80\xa0\x80"
-#define OWL_FMTEXT_UTF8_FGDEFAULT "\xf4\x80\x94\x80"
-#define OWL_FMTEXT_UTF8_BGDEFAULT "\xf4\x80\x96\x80"
-
-
-
 
 #define OWL_COLOR_BLACK     0
@@ -234,5 +212,5 @@
 #endif
 
-#define OWL_META(key) ((key)|010000)
+#define OWL_META(key) ((key)|0200)
 /* OWL_CTRL is definied in kepress.c */
 
@@ -274,16 +252,11 @@
 } owl_variable;
 
-typedef struct _owl_input {
-  int ch;
-  gunichar uch;
-} owl_input;
-
 typedef struct _owl_fmtext {
   int textlen;
   int bufflen;
   char *textbuff;
-  char default_attrs;
-  short default_fgcolor;
-  short default_bgcolor;
+  char *fmbuff;
+  short *fgcolorbuff;
+  short *bgcolorbuff;
 } owl_fmtext;
 
@@ -518,7 +491,7 @@
   owl_list  bindings;		/* key bindings */
   struct _owl_keymap *submap;	/* submap */
-  void (*default_fn)(owl_input j);	/* default action (takes a keypress) */
-  void (*prealways_fn)(owl_input  j);	/* always called before a keypress is received */
-  void (*postalways_fn)(owl_input  j);	/* always called after keypress is processed */
+  void (*default_fn)(int j);	/* default action (takes a keypress) */
+  void (*prealways_fn)(int j);	/* always called before a keypress is received */
+  void (*postalways_fn)(int j);	/* always called after keypress is processed */
 } owl_keymap;
 
Index: perl/modules/Jabber/lib/BarnOwl/Module/Jabber.pm
===================================================================
--- perl/modules/Jabber/lib/BarnOwl/Module/Jabber.pm	(revision 81312e4de65076e92c386f849f45afc1d6ab77a4)
+++ perl/modules/Jabber/lib/BarnOwl/Module/Jabber.pm	(revision 05f0061e58c81a1d32a1a1385b05b75d0b73360e)
@@ -25,6 +25,4 @@
 use Net::DNS;
 use Getopt::Long;
-
-use utf8;
 
 our $VERSION = 0.1;
@@ -375,5 +373,5 @@
                     $vars{jlogin_havepass} = 1;
                     $conn->removeConnection($jidStr);
-                    BarnOwl::start_password("Password for $jidStr: ", \&do_login );
+                    BarnOwl::start_password( "Password for $jidStr: ", \&do_login );
                     return "";
                 }
@@ -479,5 +477,5 @@
     }
     else {
-      $to = shift @ARGV;
+        $to = shift @ARGV;
     }
 
@@ -523,6 +521,5 @@
     $cmd .= " -t $jwrite_thread" if $jwrite_thread;
     $cmd .= " -s $jwrite_subject" if $jwrite_subject;
-
-    BarnOwl::start_edit_win($cmd, \&process_owl_jwrite );
+    BarnOwl::start_edit_win( $cmd, \&process_owl_jwrite );
 }
 
Index: perl/modules/Jabber/lib/BarnOwl/Module/Jabber/Connection.pm
===================================================================
--- perl/modules/Jabber/lib/BarnOwl/Module/Jabber/Connection.pm	(revision e0ffe777358f35ecd718919a91164131c03db217)
+++ perl/modules/Jabber/lib/BarnOwl/Module/Jabber/Connection.pm	(revision 892568bf6e3ceea8724cef719078e5f6c2455b16)
@@ -1,5 +1,4 @@
 use warnings;
 use strict;
-use utf8;
 
 =head1 NAME
Index: perl/modules/Jabber/lib/Net/XMPP/Debug.pm
===================================================================
--- perl/modules/Jabber/lib/Net/XMPP/Debug.pm	(revision b7b2a76676535044fc771b1bb087e020102d7af2)
+++ perl/modules/Jabber/lib/Net/XMPP/Debug.pm	(revision c2bed5539d456612d69de33e1dacc3afe5f70395)
@@ -189,5 +189,4 @@
                         {
                             $self->{HANDLE}->autoflush(1);
-                            binmode $self->{HANDLE}, ":utf8";
                             $Net::XMPP::Debug::HANDLES{$args{file}} = $self->{HANDLE};
                         }
Index: perl/modules/Jabber/lib/Net/XMPP/Message.pm
===================================================================
--- perl/modules/Jabber/lib/Net/XMPP/Message.pm	(revision 8574801f6dba0d88fd1fb74c123861816eb077f8)
+++ perl/modules/Jabber/lib/Net/XMPP/Message.pm	(revision c2bed5539d456612d69de33e1dacc3afe5f70395)
@@ -135,5 +135,5 @@
                             $Mess->SetMessage(TO=>"bob\@jabber.org",
                                               Subject=>"Lunch",
-                                              Body=>"Let's do lunch!");
+                                              BoDy=>"Let's do lunch!");
                             $Mess->SetMessage(to=>"bob\@jabber.org",
                                               from=>"jabber.org",
Index: perlconfig.c
===================================================================
--- perlconfig.c	(revision 367fbf32a41d30c32785e01d25d05b04f221728e)
+++ perlconfig.c	(revision ff13a6f4c60b5298ed361b690905db36a382fe26)
@@ -55,5 +55,5 @@
     j=owl_zephyr_get_num_fields(owl_message_get_notice(m));
     for (i=0; i<j; i++) {
-      ptr=owl_zephyr_get_field_as_utf8(owl_message_get_notice(m), i+1);
+      ptr=owl_zephyr_get_field(owl_message_get_notice(m), i+1);
       av_push(av_zfields, newSVpvn(ptr, strlen(ptr)));
       owl_free(ptr);
@@ -454,7 +454,5 @@
   PUSHMARK(SP);
   for(i=0;i<argc;i++) {
-    SV *tmp = newSVpv(argv[i], 0);
-    SvUTF8_on(tmp);
-    XPUSHs(sv_2mortal(tmp));
+    XPUSHs(sv_2mortal(newSVpv(argv[i], 0)));
   }
   PUTBACK;
@@ -490,5 +488,4 @@
 {
   SV *cb = (SV*)(e->cbdata);
-  SV *text;
   unsigned int n_a;
   dSP;
@@ -497,6 +494,4 @@
     owl_function_error("Perl callback is NULL!");
   }
-  text = newSVpv(owl_editwin_get_text(e), 0);
-  SvUTF8_on(text);
 
   ENTER;
@@ -504,5 +499,5 @@
 
   PUSHMARK(SP);
-  XPUSHs(sv_2mortal(text));
+  XPUSHs(sv_2mortal(newSVpv(owl_editwin_get_text(e), 0)));
   PUTBACK;
   
Index: text.c
===================================================================
--- text.c	(revision 47519e1bcab60a6026c4192bf5b20290f37f4737)
+++ text.c	(revision 72db971652f37640c13d75944eeb6eaf0fff645a)
@@ -50,66 +50,39 @@
 void owl_text_truncate_cols(char *out, char *in, int acol, int bcol)
 {
-  char *ptr_s, *ptr_e, *ptr_c, *tmpbuff, *last;
-  int col, cnt, padding;
-  
+  char *ptr1, *ptr2, *tmpbuff, *last;
+  int len;
+
   tmpbuff=owl_malloc(strlen(in)+20);
 
   strcpy(tmpbuff, "");
   last=in+strlen(in)-1;
-  ptr_s=in;
-  while (ptr_s<last) {
-    ptr_e=strchr(ptr_s, '\n');
-    if (!ptr_e) {
+  ptr1=in;
+  while (ptr1<last) {
+    ptr2=strchr(ptr1, '\n');
+    if (!ptr2) {
       /* but this shouldn't happen if we end in a \n */
       break;
     }
     
-    if (ptr_e==ptr_s) {
+    if (ptr2==ptr1) {
       strcat(tmpbuff, "\n");
-      ptr_s++;
-      continue;
-    }
-
-    col = 0;
-    cnt = 0;
-    padding = 0;
-    ptr_c = ptr_s;
-    while(col < bcol && ptr_c < ptr_e) {
-      gunichar c = g_utf8_get_char(ptr_c);
-      if (col + mk_wcwidth(c) > bcol) break;
-      col += mk_wcwidth(c);
-      ptr_c = g_utf8_next_char(ptr_c);
-      if (col >= acol) {
-	if (cnt == 0) {
-	  ptr_s = ptr_c;
-	  padding = col - acol;
-	}
-	++cnt;
-      }
-    }
-    if (cnt) {
-      while(padding-- > 0) {
-	strcat(tmpbuff, " ");
-      }
-      strncat(tmpbuff, ptr_s, ptr_c - ptr_s - 1);
-    }
-    strcat(tmpbuff, "\n");
-    ptr_s = ptr_e + 1;
-#if 0
+      ptr1++;
+      continue;
+    }
+
     /* we need to check that we won't run over here */
-    if ( (ptr_e-ptr_s) < (bcol-acol) ) {
-      len=ptr_e-(ptr_s+acol);
+    if ( (ptr2-ptr1) < (bcol-acol) ) {
+      len=ptr2-(ptr1+acol);
     } else {
       len=bcol-acol;
     }
-    if ((ptr_s+len)>=last) {
-      len-=last-(ptr_s+len);
-    }
-
-    strncat(tmpbuff, ptr_s+acol, len);
+    if ((ptr1+len)>=last) {
+      len-=last-(ptr1+len);
+    }
+
+    strncat(tmpbuff, ptr1+acol, len);
     strcat(tmpbuff, "\n");
 
-    ptr_s=ptr_e+1;
-#endif
+    ptr1=ptr2+1;
   }
   strcpy(out, tmpbuff);
@@ -302,16 +275,19 @@
 char *stristr(char *a, char *b)
 {
-  char *x, *y;
-  char *ret = NULL;
-  if ((x = g_utf8_casefold(a, -1)) != NULL) {
-    if ((y = g_utf8_casefold(b, -1)) != NULL) {
-      ret = strstr(x, y);
-      if (ret != NULL) {
-	ret = ret - x + a;
-      }
-      g_free(y);
-    }
-    g_free(x);
-  }
+  char *x, *y, *ret;
+
+  if ((x=owl_strdup(a))==NULL) return(NULL);
+  if ((y=owl_strdup(b))==NULL) return(NULL);
+  downstr(x);
+  downstr(y);
+  ret=strstr(x, y);
+  if (ret==NULL) {
+    owl_free(x);
+    owl_free(y);
+    return(NULL);
+  }
+  ret=ret-x+a;
+  owl_free(x);
+  owl_free(y);
   return(ret);
 }
@@ -320,15 +296,7 @@
 int only_whitespace(char *s)
 {
-  if (g_utf8_validate(s,-1,NULL)) {
-    char *p;
-    for(p = s; p[0]; p=g_utf8_next_char(p)) {
-      if (!g_unichar_isspace(g_utf8_get_char(p))) return 0;
-    }
-  }
-  else {
-    int i;
-    for (i=0; s[i]; i++) {
-      if (!isspace((int) s[i])) return(0);
-    }
+  int i;
+  for (i=0; s[i]; i++) {
+    if (!isspace((int) s[i])) return(0);
   }
   return(1);
@@ -359,5 +327,5 @@
   tolen  = strlen(to);
   fromlen  = strlen(from);
-  out = owl_malloc(outlen);
+  out = malloc(outlen);
 
   while (in[inpos]) {
Index: util.c
===================================================================
--- util.c	(revision 840270156f5630a4aeef58aaa9bb9cb1e4131f5b)
+++ util.c	(revision 89f5338caeb1828d0000cccaf478f1808203a6b1)
@@ -399,4 +399,13 @@
 }
 
+/* downcase the string 'foo' */
+void downstr(char *foo)
+{
+  int i;
+  for (i=0; foo[i]!='\0'; i++) {
+    foo[i]=tolower(foo[i]);
+  }
+}
+
 /* Caller must free response. 
  * Takes in strings which are space-separated lists of tokens
@@ -437,35 +446,49 @@
 void *owl_malloc(size_t size)
 {
-  return(g_malloc(size));
+  return(malloc(size));
 }
 
 void owl_free(void *ptr)
 {
-  g_free(ptr);
+  free(ptr);
 }
 
 char *owl_strdup(const char *s1)
 {
-  return(g_strdup(s1));
+  return(strdup(s1));
 }
 
 void *owl_realloc(void *ptr, size_t size)
 {
-  return(g_realloc(ptr, size));
+  return(realloc(ptr, size));
 }
 
 /* allocates memory and returns the string or null.
  * caller must free the string. 
+ * from Linux sprintf man page. 
  */
 char *owl_sprintf(const char *fmt, ...)
 {
+  int n, size = 100;
+  char *p;
   va_list ap;
-  char *ret = NULL;
-  va_start(ap, fmt);
-  ret = g_strdup_vprintf(fmt, ap);
-  va_end(ap);
-  return ret;
-}
-
+  if ((p = owl_malloc (size)) == NULL) return (NULL);
+  while (1) {
+    /* Try to print in the allocated space. */
+    va_start(ap, fmt);
+    n = vsnprintf (p, size, fmt, ap);
+    va_end(ap);
+    /* If that worked, return the string. */
+    if (n > -1 && n < size)
+      return p;
+    /* Else try again with more space. */
+    if (n > -1)    /* glibc 2.1 */
+      size = n+1; /* precisely what is needed */
+    else           /* glibc 2.0 */
+      size *= 2;  /* twice the old size */
+    if ((p = owl_realloc (p, size)) == NULL)
+      return NULL;
+  }
+}
 
 /* Return the owl color associated with the named color.  Return -1
@@ -753,102 +776,9 @@
 }
 
-char * owl_get_datadir()
-{
-  char * datadir = getenv("BARNOWL_DATA_DIR");
-  if(datadir != NULL)
-    return strchr(datadir, '=') + 1;
-  return DATADIR;
-}
-
-/* Strips format characters from a valid utf-8 string. Returns the
-   empty string if 'in' does not validate. */
-char * owl_strip_format_chars(char *in)
-{
-  char *r;
-  if (g_utf8_validate(in, -1, NULL)) {
-    char *s, *p;
-    r = owl_malloc(strlen(in)+1);
-    r[0] = '\0';
-    s = in;
-    p = strchr(s, OWL_FMTEXT_UC_STARTBYTE_UTF8);
-    while(p) {
-      /* If it's a format character, copy up to it, and skip all
-	 immediately following format characters. */
-      if (owl_fmtext_is_format_char(g_utf8_get_char(p))) {
-	strncat(r, s, p-s);
-	p = g_utf8_next_char(p);
-	while (p && owl_fmtext_is_format_char(g_utf8_get_char(p))) {
-	  p = g_utf8_next_char(p);
-	}
-	s = p;
-	p = strchr(s, OWL_FMTEXT_UC_STARTBYTE_UTF8);
-      }
-      else {
-	p = strchr(p+1, OWL_FMTEXT_UC_STARTBYTE_UTF8);
-      }
-    }
-    if (s) strcat(r,s);
-  }
-  else {
-    r = owl_strdup("");
-  }
-  return r;
-}
-
-/* If in is not UTF-8, convert from ISO-8859-1. We may want to allow
- * the caller to specify an alternative in the future. We also strip
- * out characters in Unicode Plane 16, as we use that plane internally
- * for formatting.
- */
-char * owl_validate_or_convert(char *in)
-{
-  if (g_utf8_validate(in, -1, NULL)) {
-    return owl_strip_format_chars(in);
-  }
-  else {
-    return g_convert(in, -1,
-		     "UTF-8", "ISO-8859-1",
-		     NULL, NULL, NULL);
-  }
-}
-/* Attempts to convert 'in' to ISO-8859-1. Returns that if possible,
-   else returns UTF-8.
- */
-char * owl_get_iso_8859_1_if_possible(char *in)
-{
-  char *out;
-  if (g_utf8_validate(in, -1, NULL)) {
-    out = g_convert(in, -1,
-		    "ISO-8859-1", "UTF-8",
-		    NULL, NULL, NULL);
-    if (!out) {
-      out = owl_strdup(in);
-    }
-  }
-  else {
-    out = owl_strdup("");
-  }
-  return out;
-}
-
-/* This is based on _extract() and _isCJ() from perl's Text::WrapI18N */
-int owl_util_can_break_after(gunichar c)
-{
-  
-  if (c == ' ') return 1;
-  if (c >= 0x3000 && c <= 0x312f) {
-    /* CJK punctuations, Hiragana, Katakana, Bopomofo */
-    if (c == 0x300a || c == 0x300c || c == 0x300e ||
-        c == 0x3010 || c == 0x3014 || c == 0x3016 ||
-        c == 0x3018 || c == 0x301a)
-      return 0;
-    return 1;
-  }
-  if (c >= 0x31a0 && c <= 0x31bf) {return 1;}  /* Bopomofo */
-  if (c >= 0x31f0 && c <= 0x31ff) {return 1;}  /* Katakana extension */
-  if (c >= 0x3400 && c <= 0x9fff) {return 1;}  /* Han Ideogram */
-  if (c >= 0xf900 && c <= 0xfaff) {return 1;}  /* Han Ideogram */
-  if (c >= 0x20000 && c <= 0x2ffff) {return 1;}  /* Han Ideogram */
-  return 0;
+char * owl_get_datadir() {
+    char * datadir = getenv("BARNOWL_DATA_DIR");
+    if(datadir != NULL)
+        return strchr(datadir, '=') + 1;
+    return DATADIR;
 }
 
Index: viewwin.c
===================================================================
--- viewwin.c	(revision 47519e1bcab60a6026c4192bf5b20290f37f4737)
+++ viewwin.c	(revision 8721756cdb2a0ef8c380c35ec3bf73d2c0e1508a)
@@ -73,5 +73,5 @@
   owl_fmtext_truncate_cols(&fm1, v->rightshift, v->wincols-1+v->rightshift, &fm2);
 
-  owl_fmtext_curs_waddstr_without_search(&fm2, v->curswin);
+  owl_fmtext_curs_waddstr(&fm2, v->curswin);
 
   /* print the message at the bottom */
Index: zcrypt.c
===================================================================
--- zcrypt.c	(revision 34509d514dfa9ee441febffc6d61e108962d1507)
+++ zcrypt.c	(revision 9ceee9d93177e80e7794f45d5ba9e611169e4d55)
@@ -385,5 +385,5 @@
 
 /* Build a space-separated string from argv from elements between start  *
- * and end - 1.  owl_malloc()'s the returned string. */
+ * and end - 1.  malloc()'s the returned string. */
 char *BuildArgString(char **argv, int start, int end) {
   int len = 1;
@@ -397,5 +397,5 @@
 
   /* Allocate memory */
-  result = (char *)owl_malloc(len);
+  result = (char *)malloc(len);
   if (result) {
     /* Build the string */
@@ -482,5 +482,5 @@
       /* Prepare result to be returned */
       char *temp = keyfile;
-      keyfile = (char *)owl_malloc(strlen(temp) + 1);
+      keyfile = (char *)malloc(strlen(temp) + 1);
       if (keyfile) {
 	strcpy(keyfile, temp);
@@ -611,5 +611,5 @@
       }
       use_buffer = TRUE;
-      if ((inptr = inbuff = (char *)owl_malloc(MAX_RESULT)) == NULL) {
+      if ((inptr = inbuff = (char *)malloc(MAX_RESULT)) == NULL) {
 	printf("Memory allocation error\n");
 	return FALSE;
@@ -639,5 +639,5 @@
       printf("Could not run zwrite\n");
       if (freein && inbuff) {
-	owl_free(inbuff);
+	free(inbuff);
       }
       return(FALSE);
@@ -685,5 +685,5 @@
 
   /* Free the input buffer, if necessary */
-  if (freein && inbuff) owl_free(inbuff);
+  if (freein && inbuff) free(inbuff);
 
   return(!error);
Index: zephyr.c
===================================================================
--- zephyr.c	(revision 10e396337dd6bf954d7f0d8ef97faf81999c7db3)
+++ zephyr.c	(revision 10e396337dd6bf954d7f0d8ef97faf81999c7db3)
@@ -354,46 +354,8 @@
   return(owl_strdup(""));
 }
-
-char *owl_zephyr_get_field_as_utf8(ZNotice_t *n, int j)
-{
-  int i, count, save;
-
-  /* If there's no message here, just run along now */
-  if (n->z_message_len == 0)
-    return(owl_strdup(""));
-
-  count=save=0;
-  for (i = 0; i < n->z_message_len; i++) {
-    if (n->z_message[i]=='\0') {
-      count++;
-      if (count == j) {
-	/* just found the end of the field we're looking for */
-	return(owl_validate_or_convert(n->z_message + save));
-      } else {
-	save = i + 1;
-      }
-    }
-  }
-  /* catch the last field, which might not be null terminated */
-  if (count == j - 1) {
-    char *tmp, *out;
-    tmp = owl_malloc(n->z_message_len-save+5);
-    memcpy(tmp, n->z_message+save, n->z_message_len-save);
-    tmp[n->z_message_len-save]='\0';
-    out = owl_validate_or_convert(tmp);
-    owl_free(tmp);
-    return out;
-  }
-
+#else
+char *owl_zephyr_get_field(void *n, int j)
+{
   return(owl_strdup(""));
-}
-#else
-char *owl_zephyr_get_field(void *n, int j)
-{
-  return(owl_strdup(""));
-}
-char *owl_zephyr_get_field_as_utf8(ZNotice_t *n, int j)
-{
-  return owl_zephyr_get_field(n, j);
 }
 #endif
Index: zwrite.c
===================================================================
--- zwrite.c	(revision 7b1d048f7f97c017e859a6805cd148da213a3bc3)
+++ zwrite.c	(revision 1fe100c61c2374e461ad9d7c12938dbf52b015b6)
@@ -44,5 +44,5 @@
 	break;
       }
-      z->class=owl_get_iso_8859_1_if_possible(myargv[1]);
+      z->class=owl_strdup(myargv[1]);
       myargv+=2;
       myargc-=2;
@@ -52,5 +52,5 @@
 	break;
       }
-      z->inst=owl_get_iso_8859_1_if_possible(myargv[1]);
+      z->inst=owl_strdup(myargv[1]);
       myargv+=2;
       myargc-=2;
@@ -60,5 +60,5 @@
 	break;
       }
-      z->realm=owl_get_iso_8859_1_if_possible(myargv[1]);
+      z->realm=owl_strdup(myargv[1]);
       myargv+=2;
       myargc-=2;
@@ -68,5 +68,5 @@
 	break;
       }
-      z->zsig=owl_get_iso_8859_1_if_possible(myargv[1]);
+      z->zsig=owl_strdup(myargv[1]);
       myargv+=2;
       myargc-=2;
@@ -76,5 +76,5 @@
 	break;
       }
-      z->opcode=owl_get_iso_8859_1_if_possible(myargv[1]);
+      z->opcode=owl_strdup(myargv[1]);
       myargv+=2;
       myargc-=2;
@@ -93,7 +93,7 @@
       myargv++;
       myargc--;
-      z->message=owl_get_iso_8859_1_if_possible("");
+      z->message=owl_strdup("");
       while (myargc) {
-	z->message=owl_realloc(z->message, strlen(z->message)+strlen(myargv[0])+5);
+	z->message=realloc(z->message, strlen(z->message)+strlen(myargv[0])+5);
 	strcat(z->message, myargv[0]);
 	strcat(z->message, " ");
@@ -113,5 +113,5 @@
     } else {
       /* anything unattached is a recipient */
-      owl_list_append_element(&(z->recips), owl_get_iso_8859_1_if_possible(myargv[0]));
+      owl_list_append_element(&(z->recips), strdup(myargv[0]));
       myargv++;
       myargc--;
@@ -146,5 +146,5 @@
 
     if (zsigowlvar && *zsigowlvar) {
-      z->zsig=owl_get_iso_8859_1_if_possible(zsigowlvar);
+      z->zsig=owl_strdup(zsigowlvar);
     } else if (zsigproc && *zsigproc) {
       FILE *file;
@@ -161,5 +161,5 @@
       if (!file) {
 	if (zsigzvar && *zsigzvar) {
-	  z->zsig=owl_get_iso_8859_1_if_possible(zsigzvar);
+	  z->zsig=owl_strdup(zsigzvar);
 	}
       } else {
@@ -175,7 +175,7 @@
       }
     } else if (zsigzvar) {
-      z->zsig=owl_get_iso_8859_1_if_possible(zsigzvar);
+      z->zsig=owl_strdup(zsigzvar);
     } else if (((pw=getpwuid(getuid()))!=NULL) && (pw->pw_gecos)) {
-      z->zsig=owl_get_iso_8859_1_if_possible(pw->pw_gecos);
+      z->zsig=strdup(pw->pw_gecos);
       ptr=strchr(z->zsig, ',');
       if (ptr) {
@@ -218,5 +218,4 @@
   int i, j;
   char toline[LINE];
-  char *tmp = NULL;
 
   if (z->message) owl_free(z->message);
@@ -232,10 +231,8 @@
       }
     }
-    tmp = owl_get_iso_8859_1_if_possible(msg);
-    z->message=owl_sprintf("%s\n%s", toline, tmp);
+    z->message=owl_sprintf("%s\n%s", toline, msg);
   } else {
-    z->message=owl_get_iso_8859_1_if_possible(msg);
-  }
-  if (tmp) owl_free(tmp);
+    z->message=owl_strdup(msg);
+  }
 }
 
@@ -308,5 +305,5 @@
 {
   if (z->opcode) owl_free(z->opcode);
-  z->opcode=owl_get_iso_8859_1_if_possible(opcode);
+  z->opcode=owl_strdup(opcode);
 }
 
